<?xml version="1.0" encoding="UTF-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">

<!-- IGAC proyecto SNC 

@author david.cifuentes   
@cu CU-NP-CO-222  			
@description Parametrizar entidades que realizan el bloqueo
@version 1.0

-->

<ui:composition xmlns="http://www.w3.org/1999/xhtml"
                xmlns:ui="http://java.sun.com/jsf/facelets"
                xmlns:f="http://java.sun.com/jsf/core"
                xmlns:h="http://java.sun.com/jsf/html"
                xmlns:p="http://primefaces.org/ui"
                xmlns:fn="http://java.sun.com/jsp/jstl/functions"
                xmlns:misc="http://java.sun.com/jsf/composite/misc"
                template="../templates/generalCU.xhtml">

    <ui:define name="content">

        <p:ajaxStatus onstart="statusDialog.show();"
                      onsuccess="statusDialog.hide();" />

        <p:messages id="msgsParametrizarEntidad" showDetail="false"
                    globalOnly="false" />

        <h:form id="parametrizarEntidadForm" prependId="true" 
                onkeypress="return event.keyCode != 13;">

            <p:fieldset>
                <legend>
                    <h:outputLabel value="Entidades que ordenan bloqueo de Predios o Personas"
                                   styleClass="legendTitle" /> 
                </legend>

                <p:spacer width="20" />

                <p:panel header="Criterios de búsqueda"  style="width:780px" id="busquedaEntidades">

                    <h:panelGrid columns="4" width="100%"  >

                        <h:panelGroup>
                            <h:outputLabel value="Departamento:" styleClass="outputLabelStyle"  />
                            <h:outputLabel value="*" styleClass="requiredLabelStyle" />
                        </h:panelGroup>                                            
                        <h:panelGrid columns="2"  >
                            <h:selectOneMenu id="busquedaEntidadesDepartamento"  
                                             requiredMessage="Debe seleccionar el departamento donde se encuentra ubicada la oficina de la entidad que puede realizar el bloqueo"  required="true" 
                                             value="#{gestionEntidadBloqueo.departamento}">
                                <f:selectItem itemLabel="Seleccionar" itemValue="" />
                                <f:selectItems
                                    value="#{gestionEntidadBloqueo.departamentosItemList}" />
                                <p:ajax listener="#{gestionEntidadBloqueo.actualizarMunicipiosBuscardorListener}"
                                        update="busquedaEntidadesMunicipio" onstart="statusDialog2.show();"
                                        oncomplete="statusDialog2.hide();" />                                                    
                            </h:selectOneMenu>
                        </h:panelGrid>   

                        <h:panelGroup>
                            <h:outputLabel value="Municipio" styleClass="outputLabelStyle" />
                            <h:outputLabel value="*" styleClass="requiredLabelStyle" />
                        </h:panelGroup>
                        <h:panelGrid columns="2">                                            
                            <h:selectOneMenu id="busquedaEntidadesMunicipio" 
                                             requiredMessage="Debe seleccionar el municipio donde se encuentra ubicada la oficina de la entidad que puede realizar el bloqueo"  
                                             required="true"
                                             value="#{gestionEntidadBloqueo.municipio}">
                                <f:selectItem itemLabel="Seleccionar" itemValue="" />
                                <f:selectItems value="#{gestionEntidadBloqueo.municipiosBuscadorItemList}" />
                            </h:selectOneMenu>
                        </h:panelGrid>                                               

                        <h:panelGroup>
                            <h:outputLabel value="Nombre entidad:" styleClass="outputLabelStyle" />
                        </h:panelGroup>
                        <h:panelGrid columns="2">
                            <p:inputText value="#{gestionEntidadBloqueo.nombreEntidad}"
                                         id="nombreEntidad" label="Nombre de la entidad"
                                         maxlength="100" style="width:250px;height:14px;">
                            </p:inputText>
                        </h:panelGrid>
                        <p:spacer height="1" width="30" />
                        <p:spacer height="1" width="30" />

                        <h:panelGroup>
                            <h:outputLabel value="Estado:" styleClass="outputLabelStyle" />
                        </h:panelGroup>
                        <h:panelGrid columns="2">
                            <h:selectOneMenu id="estadoEntidad"
                                             label="Estado de la entidad"
                                             value="#{gestionEntidadBloqueo.estadoEntidad}">
                                <f:selectItems value="#{gestionEntidadBloqueo.estadosEntidad}" />
                            </h:selectOneMenu>
                        </h:panelGrid>
                        <p:spacer height="1" width="30" />
                        <p:spacer height="1" width="30" />

                    </h:panelGrid>   

                    <p:outputPanel layout="block" style="text-align:right">
                        <p:commandButton id="buscarEntidades" icon="ui-icon-search"
                                         onstart="statusDialog2.show();" process="@this, busquedaEntidades"
                                         action="#{gestionEntidadBloqueo.buscarEntidades}"
                                         value="Buscar" update=":parametrizarEntidadForm, :msgsParametrizarEntidad"
                                         oncomplete="statusDialog2.hide();" />

                        <p:spacer width="10" />

                        <p:commandButton update=":formDetalleEntidad, :formDetalleEntidad, :parametrizarEntidadForm:panelEntidades, :msgsParametrizarEntidad"
                                         value="Registrar entidad" 
                                         oncomplete="detalleEntidadWV.show()" immediate="true"
                                         id="adicionarEntidadBtn" 
                                         action="#{gestionEntidadBloqueo.cargarEntidad}"
                                         icon="ui-icon-plus" title="Adicionar Entidad">
                            <f:setPropertyActionListener value="false"
                                                         target="#{gestionEntidadBloqueo.editModeBool}" />
                        </p:commandButton>
                    </p:outputPanel>

                </p:panel>

                <p:spacer width="10" />

                <h:panelGrid columns="1" id="panelEntidades" cellspacing="3" cellpadding="3">
                    <p:dataTable var="entidad" style="width:780px"
                                 value="#{gestionEntidadBloqueo.entidadesBloqueo}"
                                 id="tablaEntidades" paginator="true" rows="10"
                                 selectionMode="single" rowKey="#{entidad.id}"
                                 selection="#{gestionEntidadBloqueo.entidadSeleccionada}"
                                 paginatorTemplate="{RowsPerPageDropdown} {FirstPageLink} {PreviousPageLink} {CurrentPageReport} {NextPageLink} {LastPageLink}"
                                 paginatorPosition="bottom" rowsPerPageTemplate="10,20,30"
                                 emptyMessage="No se encuentran entidades resultantes.">

                        <f:facet name="header">
                            Entidades registradas
                        </f:facet>
                        <p:column headerText="Opciones" style="width:60px">
                            <p:commandButton update=":formDetalleEntidad"
                                             action="#{gestionEntidadBloqueo.cargarEntidad}"
                                             oncomplete="handleCompleteSIC(xhr, status,args, detalleEntidadWV, true);"
                                             id="modificarEntidadBtn" icon="ui-icon ui-icon-pencil"
                                             title="Editar" process="@this">
                                <f:setPropertyActionListener value="#{entidad}"
                                                             target="#{gestionEntidadBloqueo.entidadSeleccionada}" />
                                <f:setPropertyActionListener value="true"
                                                             target="#{gestionEntidadBloqueo.editModeBool}" />
                            </p:commandButton>

                            <p:commandButton id="eliminarEntidadBtn"
                                             oncomplete="handleCompleteSIC(xhr, status,args, confirmEliminarEntidadWV, true);"
                                             process="@this" icon="ui-icon-trash"
                                             title="Eliminar entidad" >
                                <f:setPropertyActionListener value="#{entidad}"
                                                             target="#{gestionEntidadBloqueo.entidadSeleccionada}" />
                                <f:setPropertyActionListener value="true"
                                                             target="#{gestionEntidadBloqueo.editModeBool}" />
                            </p:commandButton>
                        </p:column>



                        <p:column headerText="Departamento">
                            <h:outputText value="#{entidad.departamento.nombre}"
                                          styleClass="outputTextStyle" />
                        </p:column>

                        <p:column headerText="Municipio">
                            <h:outputText value="#{entidad.municipio.nombre}"
                                          styleClass="outputTextStyle" />
                        </p:column>

                        <p:column headerText="Nombre Entidad">
                            <h:outputText value="#{entidad.nombre}"
                                          styleClass="outputTextStyle" />
                        </p:column>


                        <p:column headerText="Dirección">
                            <h:outputText value="#{entidad.direccion}"
                                          styleClass="outputTextStyle" />
                        </p:column>

                        <p:column headerText="Correo electrónico">
                            <h:outputText value="#{entidad.correo}"
                                          styleClass="outputTextStyle" />
                        </p:column>

                        <p:column headerText="Estado">
                            <h:outputText value="#{entidad.estado}" id="EntidadEstadoV"
                                          styleClass="outputTextStyle">
                                <f:converter converterId="converterCB" for="EntidadEstadoV"></f:converter>
                            </h:outputText>
                        </p:column>

                    </p:dataTable>
                </h:panelGrid>

            </p:fieldset>

            <p:spacer height="10" />

            <p:outputPanel layout="block" style="text-align:right">
                <p:commandButton value="Cerrar" icon="ui-icon-close"
                                 action="#{gestionEntidadBloqueo.cerrar}" ajax="false"
                                 immediate="true" />
                <p:spacer width="10" height="10" />
            </p:outputPanel>
        </h:form>

        <misc:confirmationWithConfirmDialogCC
            confirmMessage="¿Está seguro de eliminar la entidad seleccionada?"
            confirmUpdate=":parametrizarEntidadForm,:msgsParametrizarEntidad"
            confirmAction="#{gestionEntidadBloqueo.eliminarEntidad}"
            confirmDialogWV="confirmEliminarEntidadWV" />

        <p:dialog header="Entidad"
                  dynamic="true" widgetVar="detalleEntidadWV" modal="true"
                  appendToBody="true" resizable="true" position="center">

            <h:form id="formDetalleEntidad">

                <p:spacer width="10" />

                <p:fieldset>
                    <p:messages id="msgDetalleEntidad" showDetail="false"
                                globalOnly="false" />


                    <h:panelGrid columns="4" width="100%">

                        <h:panelGroup>
                            <h:outputLabel value="Departamento:" styleClass="outputLabelStyle" />
                            <h:outputLabel value="*" styleClass="requiredLabelStyle" />
                        </h:panelGroup>                                            
                        <h:panelGrid columns="2">
                            <h:selectOneMenu id="gestionarEntidadesDepartamento"
                                             label="Debe seleccionar el departamento en el cual se encuentra ubicada la entidad que ordena el bloqueo" required="true"
                                             value="#{gestionEntidadBloqueo.departamentoSeleccionado}">
                                <f:selectItem itemLabel="Seleccionar" itemValue="" />
                                <f:selectItems
                                    value="#{gestionEntidadBloqueo.departamentosItemList}" />
                                <p:ajax listener="#{gestionEntidadBloqueo.actualizarMunicipiosListener}"
                                        update="gestionarEntidadesMunicipio" onstart="statusDialog2.show();"
                                        oncomplete="statusDialog2.hide();" />                                                    
                            </h:selectOneMenu>
                        </h:panelGrid>   


                        <h:panelGroup>
                            <h:outputLabel value="Municipio" styleClass="outputLabelStyle" />
                            <h:outputLabel value="*" styleClass="requiredLabelStyle" />
                        </h:panelGroup>
                        <h:panelGrid columns="2">                                            
                            <h:selectOneMenu id="gestionarEntidadesMunicipio" label="Debe seleccionar el municipio en el cual se encuentra ubicada la entidad que ordena el bloqueo" required="true"
                                             value="#{gestionEntidadBloqueo.municipioSeleccionado}">
                                <f:selectItem itemLabel="Seleccionar" itemValue="" />
                                <f:selectItems value="#{gestionEntidadBloqueo.municipiosItemList}" />
                            </h:selectOneMenu>
                        </h:panelGrid>                                               

                    </h:panelGrid>                                                



                    <h:panelGrid columns="2" width="100%">                                            

                        <h:panelGroup>
                            <h:outputLabel value="Nombre entidad:" styleClass="outputLabelStyle" />
                            <h:outputLabel value="*" styleClass="requiredLabelStyle" />
                        </h:panelGroup>


                        <h:panelGrid columns="2">
                            <p:inputText id="nombreEntidadDlg"
                                         value="#{gestionEntidadBloqueo.entidadSeleccionada.nombre}"
                                         label="Nombre de la entidad" required="true"
                                         requiredMessage="Debe escribir el nombre de la entidad"
                                         maxlength="100" style="width:250px;height:14px;">
                            </p:inputText>
                            <p:message for="nombreEntidadDlg" display="icon" />
                        </h:panelGrid>


                        <h:panelGroup> 
                            <h:outputLabel value="Dirección:" styleClass="outputLabelStyle" />
                        </h:panelGroup>

                        <h:panelGrid columns="2">
                            <p:inputText id="direccionEntidadDlg"
                                         value="#{gestionEntidadBloqueo.entidadSeleccionada.direccion}"
                                         label="Dirección" 
                                         maxlength="100" style="width:250px;height:14px;">
                            </p:inputText>
                        </h:panelGrid>                                                     


                        <h:panelGroup>
                            <h:outputLabel value="Correo electrónico:" styleClass="outputLabelStyle" />
                            <h:outputLabel value="*" styleClass="requiredLabelStyle" />
                        </h:panelGroup>

                        <h:panelGrid columns="2">
                            <p:inputText id="correoEntidadDlg"
                                         value="#{gestionEntidadBloqueo.entidadSeleccionada.correo}"
                                         requiredMessage="El correo electrónico es obligatorio" required="true"
                                         maxlength="100" style="width:250px;height:14px;">
                                <f:validator validatorId="emailValidator" for="correoEntidadDlg" />
                            </p:inputText>
                            <p:message for="correoEntidadDlg" display="icon" />
                        </h:panelGrid>        


                        <h:panelGroup>
                            <h:outputLabel value="Estado:" styleClass="outputLabelStyle" />
                            <h:outputLabel value="*" styleClass="requiredLabelStyle" />
                        </h:panelGroup>

                        <h:panelGrid columns="2">
                            <h:selectOneMenu id="estadoEntidadDlg" disabled="#{!gestionEntidadBloqueo.editModeBool}"
                                             label="Estado de la entidad" required="true"
                                             value="#{gestionEntidadBloqueo.entidadSeleccionada.estado}">
                                <f:selectItems value="#{gestionEntidadBloqueo.estadosEntidad}"  />
                            </h:selectOneMenu>
                            <p:message for="estadoEntidadDlg" display="icon" />
                        </h:panelGrid>
                    </h:panelGrid>

                    <p:outputPanel layout="block" style="text-align:right">
                        <p:spacer height="0" width="20" />
                        <p:commandButton
                            update=":formDetalleEntidad, :parametrizarEntidadForm, :msgsParametrizarEntidad"
                            value="Guardar"
                            process="@this, formDetalleEntidad"
                            action="#{gestionEntidadBloqueo.guardarEntidad}"
                            oncomplete="handleCompleteSIC(xhr, status, args, detalleEntidadWV, false)"
                            icon="ui-icon ui-icon-disk" id="guardarBtn"
                            title="Guardar entidad">
                        </p:commandButton>
                        <p:spacer height="30" width="20" />
                        <p:commandButton value="Cerrar" style="height:30x;"
                                         oncomplete="detalleEntidadWV.hide();"
                                         icon="ui-icon-close" id="botonCerrarDetalleEntidad" />
                    </p:outputPanel>

                </p:fieldset>
            </h:form>
        </p:dialog>

    </ui:define>

</ui:composition>